From a23129c06994718dc70e7b1a81db56cb1a7e0c60 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 09 2020 03:08:28 +0000
Subject: [PATCH 217/2232] Allow calling fn pointers with explicit indirect call syntax


---

diff --git a/include/cxx.h b/include/cxx.h
index 3dd52e5..8bdbc90 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -155,6 +155,7 @@ template <typename Ret, typename... Args, bool Throws>
 class Fn<Ret(Args...), Throws> {
 public:
   Ret operator()(Args... args) noexcept(!Throws);
+  Fn operator*() noexcept;
 
 private:
   Ret (*trampoline)(Args..., void *fn) noexcept(!Throws);
@@ -204,5 +205,10 @@ Ret Fn<Ret(Args...), Throws>::operator()(Args... args) noexcept(!Throws) {
   return (*this->trampoline)(std::move(args)..., this->fn);
 }
 
+template <typename Ret, typename... Args, bool Throws>
+Fn<Ret(Args...), Throws> Fn<Ret(Args...), Throws>::operator*() noexcept {
+  return *this;
+}
+
 } // namespace cxxbridge02
 } // namespace rust

